From: John Ferrier <john_j_ferrier@yahoo.com>
Subject: [PATCH] textDisp: cursor position correction

One missing patch is a correction for the cursor display.  Maybe it is
originally from Thorsten Haude or Tony, which I am not sure now.  However,
the difference is as follows:

---

 source/textDisp.c |   37 +++++++++++++++++++++++++++++--------
 1 file changed, 29 insertions(+), 8 deletions(-)

diff --quilt old/source/textDisp.c new/source/textDisp.c
--- old/source/textDisp.c
+++ new/source/textDisp.c
@@ -1427,7 +1427,7 @@ int TextDMoveLeft(textDisp *textD)
 
 int TextDMoveUp(textDisp *textD, int absolute)
 {
-    int lineStartPos, column, prevLineStartPos, newPos, visLineNum;
+    int lineStartPos, column, prevLineStartPos, newPos, visLineNum, offset = 1;
     
     /* Find the position of the start of the line.  Use the line starts array
        if possible, to avoid unbounded line-counting in continuous wrap mode */
@@ -1448,13 +1448,24 @@ int TextDMoveUp(textDisp *textD, int abs
             ? textD->cursorPreferredCol
             : BufCountDispChars(textD->buffer, lineStartPos, textD->cursorPos);
     
+    /* In continuous mode if the wrapping occurs at a non-whitespace character,
+       the cursor is moved to the start of the next line, cf. TextDEndOfLine.
+       Therefore in this rare special case the previous line is two(!) displayed
+       lines away. */
+    if (textD->continuousWrap) {
+        if (column > 0 && lineStartPos == textD->cursorPos) {
+            if (lineStartPos == TextDEndOfLine(textD, lineStartPos - 1, False))
+                offset = 2;
+        }
+    }
+
     /* count forward from the start of the previous line to reach the column */
     if (absolute) {
         prevLineStartPos = BufCountBackwardNLines(textD->buffer, lineStartPos, 1);
-    } else if (visLineNum != -1 && visLineNum != 0) {
-        prevLineStartPos = textD->lineStarts[visLineNum-1];
+    } else if (visLineNum >= offset) {
+        prevLineStartPos = textD->lineStarts[visLineNum - offset];
     } else {
-        prevLineStartPos = TextDCountBackwardNLines(textD, lineStartPos, 1);
+        prevLineStartPos = TextDCountBackwardNLines(textD, lineStartPos, offset);
     }
 
     newPos = BufCountForwardDispChars(textD->buffer, prevLineStartPos, column);
@@ -1472,7 +1483,7 @@ int TextDMoveUp(textDisp *textD, int abs
 
 int TextDMoveDown(textDisp *textD, int absolute)
 {
-    int lineStartPos, column, nextLineStartPos, newPos, visLineNum;
+    int lineStartPos, column, nextLineStartPos, newPos, visLineNum, offset = 1;
 
     if (textD->cursorPos == textD->buffer->length) {
         return False;
@@ -1492,10 +1503,20 @@ int TextDMoveDown(textDisp *textD, int a
             ? textD->cursorPreferredCol
             : BufCountDispChars(textD->buffer, lineStartPos, textD->cursorPos);
 
+    /* In continuous mode if the wrapping occurs at a non-whitespace character,
+       the cursor is moved to the start of the next line, cf. TextDEndOfLine.
+       Therefore in this rare special case we are already on the next line! */
+    if (textD->continuousWrap) {
+        if (column > 0 && lineStartPos == textD->cursorPos) {
+            if (lineStartPos == TextDEndOfLine(textD, lineStartPos - 1, False))
+                offset = 0;
+        }
+    }
+
     if (absolute)
         nextLineStartPos = BufCountForwardNLines(textD->buffer, lineStartPos, 1);
     else
-        nextLineStartPos = TextDCountForwardNLines(textD, lineStartPos, 1, True);
+        nextLineStartPos = TextDCountForwardNLines(textD, lineStartPos, offset, True);
 
     newPos = BufCountForwardDispChars(textD->buffer, nextLineStartPos, column);
 
@@ -1759,7 +1780,7 @@ static void bufModifiedCB(int pos, int n
     	    endDispPos = textD->continuousWrap ? wrapModEnd :
     	    	    BufEndOfLine(buf, pos + nInserted) + 1;
     	    if (origCursorPos >= startDispPos &&
-    	    	    (origCursorPos <= endDispPos || endDispPos == buf->length))
+    	    	    (origCursorPos <= endDispPos || endDispPos >= buf->length))
     	    	blankCursorProtrusions(textD);
     	}
         /* If more than one line is inserted/deleted, a line break may have
@@ -3314,7 +3335,7 @@ static void blankCursorProtrusions(textD
         width = left - x;
     } else if (cursorX >= right - cursorWidth/2 && cursorX <= right) {
         x = right;
-        width = cursorX + cursorWidth/2 + 2 - right;
+        width = cursorX + cursorWidth/2 + cursorWidth - right;
     } else
         return;
         
